function [ff,ix,Gamma,Gam_muG] = ffindomega(omega,sigma,mu,Fomegabar,s)
% The following definitions are taken from BGG page 52 (NBER WP 6455)
z       =   (log(omega)+sigma^2/2)/sigma;
Gamma   =   normcdf(z-sigma)+omega*(1-normcdf(z));
Gam_muG =   (1-mu)*normcdf(z-sigma)+omega*(1-normcdf(z));

% omegabareq(1) corresponds to equation (zz1) in the manuscript
% omegabareq(2) is the definition of Fomegabar
ff  =   (1-Gamma)*s+(1-Fomegabar)/(1-Fomegabar-mu*omega*lognpdf(omega,-sigma^2/2,sigma))*(s*Gam_muG-1);

ix=0;
if max(abs(imag(ff))) > .1e-8 | (1-Fomegabar)/(1-Fomegabar-mu*omega*lognpdf(omega,-sigma^2/2,sigma)) < 0
    ix=1;
end