function [sigma,ix] = ffsigma(omega,Fomega)
% This routine finds the value of sigma
%for the lognormal distribution with mean
%forced to equal zero, such that prob < omega = Fomega.
%For Fomega = .03, this program requires
%omega to live in the interval 
%[0.000000001,0.999];
ix=0;
sigma1=.00000001;
[ff1] = findsigma(sigma1,omega,Fomega);
sigma2=5;
[ff2] = findsigma(sigma2,omega,Fomega);
if ff1*ff2 > 0
    ix=1;
    sigma=[];
    return
end
x0=[sigma1 sigma2];
opt=optimset('diagnostics','on','LevenbergMarquardt','on','TolX',1e-12,'TolFun',1e-12);
[sigma,fval,exitflag,output] =   fzero(@findsigma,x0,opt, ...
    omega,Fomega);
if abs(fval ) > .1e-9 | abs(imag(sigma))>.1e-10 | sigma < 0 | exitflag <= 0
    ix=2;
    sigma=[];
    return
end

    
    

