function [ff,c,mb,lamz,Fomegabar,Gamma,G,Rk,rk,n,k,w,l,i,y,vk,costs,erz] = findomegabar(omegabar,sigma,Re,mu,tauk,delta,upsil,pii,we,gamma,muzstar,lambdaf,alpha,psik,R,psil, ...
        ksi,chorse,dm,lambdaw,zeta,psiL,sigmaL,taul,tauc,m,chii,theta,sigmaq,b,beta,v,etag,ev,bigtheta,tau,her)
    
% The following definitions are taken from BGG page 52 (NBER WP 6455)
Fomegabar = logncdf(omegabar,-.5*sigma^2,sigma);
z       =   (log(omegabar)+sigma^2/2)/sigma;
Gamma   =   normcdf(z-sigma)+omegabar*(1-normcdf(z));
G       =   normcdf(z-sigma);
hh      =   lognpdf(omegabar,-sigma^2/2,sigma)/(1-Fomegabar);

Rk = -1 + ((1+Re)/(1-mu*omegabar*hh))* (1-Gamma + (Gamma-mu*G)/(1-mu*omegabar*hh) )^(-1);

rk = ((Rk+1-tauk*delta)*(upsil/pii)-(1-delta))/(1-tauk);

n    =   we/(1-gamma/muzstar*(1+Re)/pii-gamma/(pii*muzstar)*(Rk-Re-mu*(1+Rk)*G)/(1-(1+Rk)/(1+Re)*(Gamma-mu*G)));

k    =   n/(1-((1+Rk)/(1+Re))*(Gamma-mu*G));

%equation aa1
w  = (lambdaf*(1/(1-alpha))^(1-alpha)*(1/alpha)^alpha*(rk*(1+psik*R))^alpha *(1+psil*R)^(1-alpha))^(-(1/(1-alpha)));

%equation aa2
l  = (k/(muzstar*upsil))*((1-alpha)/alpha)*(rk*(1+psik*R)/(w*(1+psil*R)));

%equation aa3
i  = k*(1-(1-delta)/(muzstar*upsil));

mb = (psil*w*l + psik*rk*k/(muzstar*upsil))*(1+tau*her/(1-ksi)) / (her*(1-tau)*(1-m)/((1-ksi)*pii*muzstar)-(1-m-chorse*dm)/(pii*muzstar));

lamz = lambdaw*zeta*psiL*l^sigmaL/(w*(1-taul));

opt=optimset('diagnostics','off','LevenbergMarquardt','on','TolX',1e-15,'TolFun',1e-15);
[c,fval,exitflag,output] =   fzero(@findc,[0,100],opt,pii,muzstar,dm,tauc,m,chii,theta,sigmaq,b,beta,v,lamz,mb);
if abs(fval ) > .1e-9 | abs(imag(c))>.1e-10 | exitflag <= 0
    error('fatal (findomegabar) failed to find c')
end

y = (c+i)/(1-etag);

vk = (y + bigtheta*(1-gamma)*(n-we)/gamma + mu*G*(1-Rk)*k/(muzstar*pii) ) / ( (1/lambdaf)*(k/(muzstar*upsil))^alpha*l^(1-alpha)  );

%equation aa13
costs=psil*w*l+psik*rk*k/(upsil*muzstar);
erz=(1-tau)*(mb/(pii*muzstar))*(1-m)-tau*costs;
ff = ev - erz/ ( (1-vk)*((k/(upsil*muzstar))^alpha)*(l^(1-alpha)) );

