function forecast(xparam1,gend,data)

global muzstarUU piUU iUU cUU hUU RXUU upsilUU

global bayestopt_ exo_nbr dr_ estim_params_ Sigma_e_ options_ xparam1_test
global trend_coeff_ lgy_ oo_ lgx_

% alphabetical ordering of variables in the state....

% dr_.order_var - maps re-ordered variables in the state into alphabetical ordering. that is,
% lgy_(dr_.order_var,:) is the reordered state. For example, consider the
% 10th variable in the reordered state, which is epsilU. Then, because the
% variables in lgy_ are in alphabetical order,
% lgy_(dr_.order_var(10),:)=epsilU.
% dr_.inv_order_var - takes variables in their alphabetical order and maps them 
% into their re-ordered order. (i.e., % lgy_(dr_.order_var(dr_.inv_order_var),:)=lgy_).
% bayestopt_.mf - variables in the observer equation, re-ordered
% bayestopt_.mfys - variables in the observer equation, alphabetical order


ip =0;%this looks at the shape of the criterion in the direction of negative eigenvalues
if ip == 1
    load hh1 hh
    ix=0;
    gam=-.000001:.0000001:.000001;
    [P,om]=eig(hh);
    for ii = 1:size(hh,1)
        if real(om(ii,ii)) < 0
            ix=ix+1;
            II(ix)=ii;
            pp=real(P(:,ii));
            for jj = 1:length(gam)
                xpar=xparam1+pp*gam(jj);
                [fval] = DsgeLikelihood(xpar,gend,data);
                ff(jj)=fval;
            end
            subplot(2,3,ix)
            plot(gam,ff)
            axis tight
        end
    end
end
    
%get the data for the G project...
gdata

%variables in lgy_ are endogenous variables, in alphabetical order
vbl=lgy_(bayestopt_.mfys,:);
Y=[];
for ii = 1:size(vbl,1)
    eval(['Y=[Y;' deblank(vbl(ii,:)) '''];'])
end

mm=mean(Y')';


mf    = bayestopt_.mf;
nobs 		= size(options_.varobs,1);
smpl        = size(Y,2);

Q = Sigma_e_;
for i=1:estim_params_.nvx
	k =estim_params_.var_exo(i,1);
	Q(k,k) = xparam1(i)*xparam1(i);
end
offset = estim_params_.nvx;
if estim_params_.nvn
	H = zeros(nobs,nobs);
	for i=1:estim_params_.nvn
		k = estim_params_.var_endo(i,1);
		H(k,k) = xparam1(i+offset)*xparam1(i+offset);
	end
end	
offset = offset+estim_params_.nvn;
for i=1:estim_params_.ncx
	k1 =estim_params_.corrx(i,1);
	k2 =estim_params_.corrx(i,2);
	Q(k1,k2) = xparam1(i+offset)*sqrt(Q(k1,k1)*Q(k2,k2));
	Q(k2,k1) = Q(k1,k2);
end
offset = offset+estim_params_.ncx;

if estim_params_.nvn & estim_params_.ncn 
	for i=1:estim_params_.ncn
		k1 = options_.lgyidx2varobs(estim_params_.corrn(i,1));
		k2 = options_.lgyidx2varobs(estim_params_.corrn(i,2));
		H(k1,k2) = xparam1(i+offset)*sqrt(H(k1,k1)*H(k2,k2));
		H(k2,k1) = H(k1,k2);
	end
	offset = offset+estim_params_.ncn;
end	
for i=1:estim_params_.np
	assignin('base',deblank(estim_params_.param_names(i,:)),xparam1(i+offset));
end

Sigma_e_ = Q;
[T,R,SteadyState] = dynare_resolve;
%SteadyState - variables are in the alphabetical order 
constant = SteadyState(bayestopt_.mfys);

if estim_params_.nvn == 0
     H=zeros(length(mf));
end

II=eye(size(T,2));
Z=II(mf,:);

% Pstar = lyapunov_symm(T,R*Q*transpose(R));
% 
% a=std([dy dc dinve labobs pinfobs dw robs]);
% fprintf('dy in data (model) = %7.4f (%7.4f)\n',a(1),sqrt(Pstar(4,4)))
% fprintf('dc in data (model) = %7.4f (%7.4f)\n',a(2),sqrt(Pstar(1,1)))
% fprintf('dinve in data (model) = %7.4f (%7.4f)\n',a(3),sqrt(Pstar(2,2)))
% fprintf('labobs in data (model) = %7.4f (%7.4f)\n',a(4),sqrt(Pstar(7,7)))
% fprintf('pinfobs in data (model) = %7.4f (%7.4f)\n',a(5),sqrt(Pstar(9,9)))
% fprintf('dw in data (model) = %7.4f (%7.4f)\n',a(6),sqrt(Pstar(3,3)))
% fprintf('robs in data (model) = %7.4f (%7.4f)\n',a(7),sqrt(Pstar(10,10)))
[Pstar,C1,C2,C3] = print2moments(Z,H,T,R,Q,dly,linfl,dli,dlc,RXU,dlgd,dlpi,dlh,upsilUU,muzstarUU,piUU,hUU,iUU,cUU,RXUU,mf,xparam1,Y,estim_params_.nvx,estim_params_.var_exo,lgx_,time);

%
%  Input:
%  The observed data are Y(:,t), t=1,...,T.
%  Observer equation: Y(:,t)=H*ksi(:,t)+w(:,t), w iid, Ew*w'=RR.
%  State evolution equation: ksi(:,t+1)=F*ksi(:,t)+nu(:,t+1), nu iid, Enu*nu'=QQ.
%  P unconditional variance of ksi (This is P1|0 in Hamilton's notation.)
%
%  Output:
%  Yhat(:,t)=E[H*ksi(:,t)|information(t1)], for t=t1,...,t1+L,
%  where t1>=1, information(t1)={Y(:,1),...,Y(:,t1)}.
%  VAR(:,:,t) = variance of Yhat(:,t) forecast given information(t1), for
%  t=t1,...,t1+L.
%
   RR=H;
   F=T;
   QQ=R*Q*R';
   P=Pstar;
   H=Z;
   mm=mean(Y(:,[t1-12:t1])')';
   YY=Y(:,[1:t1])-repmat(mm,1,t1);
   [xsmooth, Vsmooth, VVsmooth, loglik] = kalman_smoother(YY, F, H, QQ, RR, zeros(size(H,2),1), P);
   L=12;
   if t1+L > length(dly)
       return
   end
   [Yhat,VYhat] = forecastkalman(YY,H,F,QQ,RR,P,t1,L);

   xini=zeros(size(T,1),1);
   alf=zeros(size(Z,1),1);
   [loglik,Ft,ut] = mykalman(YY,F,H,QQ,RR,xini,P,alf);
   lnprior = priordens(xparam1,bayestopt_.pshape,bayestopt_.p1,bayestopt_.p2,bayestopt_.p3,bayestopt_.p4);
   fval    = (loglik-lnprior);
   fprintf(' posterior mode computed using mykalman = %8.4f\n',fval)
   fprintf(' std dev of one-step-ahead forecast error in indicated observed variable\n')
   fprintf(' implied by estimated model (corresponding empirical estimate)\n')
   sss=std(ut');
   for ii = 1:length(bayestopt_.mfys)
       ss=[lgy_(bayestopt_.mfys(ii),:) ' = %8.4f ( = %8.4f)\n'];
       fprintf(ss,sqrt(Ft(ii,ii)),sss(ii))
   end
   

   k=50;
   II=find(diag(Q)~=0);
   Qt=Q(II,II);
   Rt=R(:,II);
   [C,B] = getvar(F,Rt,H,Qt,k);   
   Yhat=Yhat+repmat(mm,1,size(Yhat,2));
   tt=[t1+1:t1+L];
   oo_.Forecast_mean.dly=Yhat(1,tt);
   oo_.Forecast_mean.piU=Yhat(2,tt);
   oo_.Forecast_mean.lhU=Yhat(3,tt);
   oo_.Forecast_mean.dli=Yhat(4,tt);
   oo_.Forecast_mean.dlc=Yhat(5,tt);
   oo_.Forecast_mean.RXU=Yhat(6,tt);   
   oo_.Forecast_var.dly=VYhat(1,tt);
   oo_.Forecast_var.piU=VYhat(2,tt);
   oo_.Forecast_var.lhU=VYhat(3,tt);
   oo_.Forecast_var.dli=VYhat(4,tt);
   oo_.Forecast_var.dlc=VYhat(5,tt);
   oo_.Forecast_var.RXU=VYhat(6,tt);
   if size(YY,1) == 7
       oo_.Forecast_mean.dlDJ=Yhat(7,tt);
       oo_.Forecast_var.dlDJ=VYhat(7,tt);   
   end
   ia=6;
   if size(YY,1)==7;ia=7;end
   oo_.Forecast_mean.RXU=Yhat(ia,tt);
   oo_.Forecast_var.RXU=VYhat(ia,tt);
   oo_.Actual_mean.dly=Y(1,tt);
   oo_.Actual_mean.piU=Y(2,tt);
   oo_.Actual_mean.lhU=Y(3,tt);
   oo_.Actual_mean.dli=Y(4,tt);
   oo_.Actual_mean.dlc=Y(5,tt);
   if size(YY,1)==7;oo_.Actual_mean.dlDJ=Y(7,tt);end
   oo_.Actual_mean.RXU=Y(ia,tt);
   oo_.ForecastPeriod=tt;
   return
 %  Yhat=Yhat+repmat(constant,1,size(Yhat,2));
   
   %figure
   
   for ii = 1:2
       subplot(2,1,ii)
       tt=1:size(Y,2);
       if min((VYhat(ii,ii,:))) < -.1e-10
           disp('alert! (forecast) forecast error variances negative')
           disp('you have control of the keyboard')
           keyboard
       end
       aa=sqrt(squeeze(abs(VYhat(ii,ii,:))));
       ss=[1:t1];
       if ii ~= 2;plot(time([1:size(Yhat,2)]),Yhat(ii,:),time,Y(ii,:),time([1:size(Yhat,2)]),Yhat(ii,:)+2*aa',time([1:size(Yhat,2)]),Yhat(ii,:)-2*aa' ...
           ,time,mm(ii)*ones(length(time),1));end
       if ii == 2;plot(time([1:size(Yhat,2)]),400*(Yhat(ii,:)-1),time,400*(Y(ii,:)-1),time([1:size(Yhat,2)]),400*(Yhat(ii,:)-1)+2*400*aa',time([1:size(Yhat,2)]),400*(Yhat(ii,:)-1)-2*400*aa' ...
           ,time,400*(mm(ii)-1)*ones(length(time),1));end
       title(lgy_(dr_.order_var(mf(ii)),:))
       axis tight
   end
   pause(1)
   disp('')