// this modifies the model without financial frictions.
// we replace the households intertemporal euler equation for capital and the resource constraint by equations
// provided by the financial frictions. The programming of the steady state restricts the parameter values somewhat (see the check below).
// The steady state code could be modified to change this.
// Notation: UU - parameter, U - variable, if there are uppercase letters, then (because dynare 3 did not recognize uppercase) there is an X

dbstop if error

var piU sU rkU iU RkXU qU RXU uzcU cU wU lhU kbarU pstarU wstarU FpXU KpXU FwXU KwXU wplusU yzU 
    lambdafU dly dli dlc uU gdU gndU Util Welf serialmps epsilU zetaiU zetacU pitargetU
     signalstate1 signalstate2 signalstate3 signalstate4 signalstate5 signalstate6 signalstate7 
    signalstate8 muupU dlgd dlpi dlh linfl SXU SpXU lambdazU muzstarU ygdpU zetaU tauoU pitildewU piwU FXU
// variables associated with entrepreneurs
    loansU premU omegabarU sigmaU nU dU gammaU FprimeU GXU FomegaXU GAMMAXU riskyRXU;

varexo tau0x taulx taukx lambdafx mps epsilx zetaix zetacx sig1 sig2 sig3 sig5 sig6 sig7 sig8 sig4 gdx gndx pitargetx muupx muzstarx zetax sigmax gammax;

//PARAMETERS (these are placed in M_.params)
parameters rkUU, nUU, kUU, hUU, iUU, wUU, dUU, cUU,lambdazUU, yzUU, sigmaUU, omegabarUU, phiUU, mcUU, pitildUU, pstarUU,
        pitildwUU, wstarUU, wplusUU, RkXUU, RXUU, FpXUU, KpXUU, FwXUU, KwXUU, uczUU, qUU, GammaXUU, Gam_muGXUU,
        lambdafUU, piUU, muzstarUU, betaUU, deltaUU, FomegabarXUU, muUU, alphaUU, gammaUU, sigmaLXUU,
        psiLXUU, lambdawUU, weUU, bigthetaUU, bUU, muupUU, taukUU, upsilUU, iota1UU, iota2UU,
        pibarUU, xipUU, iotaw1UU, iotaw2UU, xiwUU, epsilUU, gdUU, gndUU, zetaiUU, tauoUU, zetaUU, psikUU, psilUU, rhoUU, zetacUU, 
        xUU, pitargetUU, nbeta,piwUU,
        rhotilUU,aptilUU,aytilUU,taucUU,SdouprXUU,sigmaaUU, iotamuUU, taulUU, actilUU,
        rho_lambdafUU, rho_zetaiUU, rho_zetacUU, rho_gammaUU,rho_sigmaUU,rho_muupUU,rho_muzstarUU,rho_zetaUU, rho_tauoUU,
        lambdawsUU,lambdafsUU,rholUU,rho_muuplUU,rho_lambdaflUU,rho_muzstarlUU,rho_zetaclUU,rho_zetailUU,
        rho_mps, rho_gU, respnd,rho1d,rho2d,rho3d,rho1nd,rho2nd,rho3nd,rho_pitargetUU,
        rho1_taul, rho2_taul, rho3_taul, rho1_tauk, rho2_tauk, rho3_tauk, dtaul, dtauk, resptaul, resptauk, ygdpUU,
        taulU,taukU;

params_mode;
tauoUU=tauoUUst;
zetaiUU=zetaiUUst;
zetaUU=zetaUUst;
zetacUU=zetacUUst;
nbeta=nbetast;

if abs(taukUUst) > .1e-8 | abs(taulUUst) > .1e-8 | abs(taucUUst) > .1e-8 |abs(iotamuUUst) > .1e-8 | abs(upsilUUst-1) > .1e-8
   error('fatal (model_financial) cannot handle this case');
else
   taukUU=0;
   taulUU=0;
   taucUU=0;
   iotamuUU=0;
   taulU=taulUU;
   taukU=taukUU;
   psikUU=psikUUst;
   psilUU=psilUUst;
end

// get parameter values and steady states... 
[xgdUU,xgndUU,xrkUU, xnUU, xkUU, xhUU, xiUU, xwUU, xdUU, xcUU, xlambdazUU, xyzUU, xsigmaUU, xomegabarUU, xphiUU, xmcUU, xpitildUU, xpstarUU, xpiwUU,xpitildwUU, xwstarUU, xwplusUU, xRkXUU, xRXUU, xFpXUU, xKpXUU, xFwXUU, xKwXUU, xuczUU, xqUU, xGammaXUU, xGam_muGXUU,xlambdafUU, xpiUU, xmuzstarUU, xbetaUU, xdeltaUU, xFomegabarXUU, xmuUU, xalphaUU, xgammaUU, xsigmaLXUU,xpsiLXUU, xlambdawUU, xweUU, xbigthetaUU, xbUU, xmuupUU, xtaukUU, xupsilUU, xiota1UU, xiota2UU,xpibarUU, xxipUU, xiotaw1UU, xiotaw2UU, xxiwUU, xepsilUU,xxUU,xrhotilUU,xaptilUU,xaytilUU,xactilUU,xSdouprXUU,xsigmaaUU,xlambdawsUU,xlambdafsUU] = getsteadyexogm;

// assign values computed in sstate to variables declared as parameters in the parameter statement
gdUU=xgdUU;gndUU=xgndUU;rkUU=xrkUU; nUU=xnUU; kUU=xkUU; hUU=xhUU; iUU=xiUU; wUU=xwUU; 
dUU=xdUU; cUU=xcUU; lambdazUU=xlambdazUU; yzUU=xyzUU; sigmaUU=xsigmaUU; 
omegabarUU=xomegabarUU; phiUU=xphiUU; mcUU=xmcUU; pitildUU=xpitildUU; 
pstarUU=xpstarUU; piwUU=xpiwUU;pitildwUU=xpitildwUU; wstarUU=xwstarUU; 
wplusUU=xwplusUU; RkXUU=xRkXUU; RXUU=xRXUU; FpXUU=xFpXUU; KpXUU=xKpXUU; 
FwXUU=xFwXUU; KwXUU=xKwXUU; uczUU=xuczUU; qUU=xqUU; GammaXUU=xGammaXUU; 
Gam_muGXUU=xGam_muGXUU;lambdafUU=xlambdafUU; piUU=xpiUU; muzstarUU=xmuzstarUU; 
betaUU=xbetaUU; deltaUU=xdeltaUU; FomegabarXUU=xFomegabarXUU; muUU=xmuUU; 
alphaUU=xalphaUU; gammaUU=xgammaUU; sigmaLXUU=xsigmaLXUU;psiLXUU=xpsiLXUU; 
lambdawUU=xlambdawUU; weUU=xweUU; bigthetaUU=xbigthetaUU; bUU=xbUU; muupUU=xmuupUU; 
taukUU=xtaukUU; upsilUU=xupsilUU; iota1UU=xiota1UU; iota2UU=xiota2UU;pibarUU=xpibarUU;
xipUU=xxipUU; iotaw1UU=xiotaw1UU; iotaw2UU=xiotaw2UU; xiwUU=xxiwUU; epsilUU=xepsilUU;
xUU=xxUU;rhotilUU=xrhotilUU;aptilUU=xaptilUU;aytilUU=xaytilUU;actilUU=xactilUU;
SdouprXUU=xSdouprXUU;sigmaaUU=xsigmaaUU;lambdawsUU=xlambdawsUU;lambdafsUU=xlambdafsUU;

// get values for the stochastic parameters of the model
paramsshocks 

// assign values to the names of the stochastic parameters
rho_lambdafUU=rho_lambdafUUst;rho_zetaiUU=rho_zetaiUUst;
rho_zetaUU=rho_zetaUUst;rho_zetacUU=rho_zetacUUst;
rho_gammaUU=rho_gammaUUst;rho_sigmaUU=rho_sigmaUUst;
rho_muupUU=rho_muupUUst;rho_muzstarUU=rho_muzstarUUst;
rho_mps=rho_mpsst;rho_tauoUU=rho_tauoUUst;rho_pitargetUU=rho_pitargetUUst;
rho1nd=rho1ndst;rho2nd=rho2ndst;rho3nd=rho3ndst;respnd=respndst;
rhoUU=rhoUUst;rho1d=rho1dst;rho2d=rho2dst;rho3d=rho3dst;
rho1_taul=rho1_taulst;rho2_taul=rho2_taulst;
rho3_taul=rho3_taulst;rho1_tauk=rho1_taukst;
rho2_tauk=rho2_taukst;rho3_tauk=rho3_taukst;
resptaul=resptaulst;resptauk=resptaukst;
dtaul=dtaulst;dtauk=dtaukst;

pitargetUU=(1+xUU)/muzstarUU;

UtilUU = zetacUU*(log(cUU*muzstarUU-bUU*cUU)-zetaUU*psiLXUU/(1+sigmaLXUU)*(wstarUU/wplusUU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hUU^(1+sigmaLXUU));
WelfUU=UtilUU/(1-nbeta);
xUtilUU=UtilUU;xWelfUU=WelfUU;
ygdpUU = gdUU + gndUU + cUU + iUU/muupUU;
ixx=1;
pitildewUU=(pitargetUU^iotaw1UU)*(piUU^iotaw2UU)*(pibarUU^(1-iotaw1UU-iotaw2UU));
if abs(pitildewUU-pitildwUU) > .1e-10
  error('fatal (model_financial) two different ss values for pitilde')
end

model;

// period utility
Util = zetacU*(log(cU*muzstarU-bUU*cU(-1))-zetaU*psiLXUU/(1+sigmaLXUU)*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*exp(lhU)^(1+sigmaLXUU));

// welfare
Welf = Util + nbeta*Welf(+1);

// Monetary Policy Rule
log(1+RXU) = (1-rhotilUU)*log(1+RXUU) + rhotilUU*log(1+RXU(-1)) + (1/(1+RXUU))*(1-rhotilUU)*aptilUU*piUU*(log(piU(+1)/pitargetU)) 
   + (1-rhotilUU)*aytilUU*(1/(4*(1+RXUU)))*log(ygdpU/ygdpUU) + serialmps;

//marginal cost in terms of both factor costs
-sU+((1-alphaUU)^(alphaUU-1)*alphaUU^(-alphaUU))*((rkU*(1+psikUU*RXU))^alphaUU)*((wU*(1+psilUU*RXU))^(1-alphaUU))/epsilU;

//marginal cost in terms of rental rate of capital
rkU*(1+psikUU*RXU)/( alphaUU*epsilU*( (upsilUU*muzstarU*( exp(lhU)*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )/(uU*kbarU(-1)))^(1-alphaUU) ) )-sU;

// multiplier on household budget constraint is zetacU*lambdazU
lambdazU=uzcU/(zetacU*(1+taucUU));

//adjustment cost function
SXU= exp( ( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))
  +  exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU)) - 2 ;

//derivative of adjustment cost function
SpXU=  sqrt(SdouprXUU/2) * ( exp( ( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU)) 
                           - exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU)) )  ;

//I fonc
zetacU*lambdazU/muupU = zetacU*qU*lambdazU*(1-SXU-SpXU*zetaiU*upsilUU*muzstarU*iU/iU(-1))
  + betaUU*(zetacU(+1)*zetaiU(+1)*qU(+1)*lambdazU(+1)/(upsilUU*muzstarU(+1)))*SpXU(+1)*(upsilUU*muzstarU(+1)*iU(+1)/iU)^2;

//this is the first order condition associated with utilization
rkU - tauoU*rkUU*exp(sigmaaUU*(uU-1));

// definition of rate of return on capital
RkXU - ( ( (1-taukU)*(uU*rkU-tauoU*( rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU ))+(1-deltaUU)*qU)*piU/(upsilUU*qU(-1)) + taukU*deltaUU - 1);

// marginal utility of consumption
 uzcU - (muzstarU*zetacU/(cU*muzstarU-bUU*cU(-1))) + bUU*betaUU*zetacU(+1)/(cU(+1)*muzstarU(+1)-bUU*cU);

// definition of nominal rate of interest
(betaUU*zetacU(+1)* lambdazU(+1)/(piU(+1)*muzstarU(+1)))*(1+RXU) - zetacU*lambdazU ;

// ex ante real rate of interest
(betaUU*zetacU(+1)*lambdazU(+1)/(muzstarU(+1)))*FXU - zetacU*lambdazU;

// output
yzU - ((pstarU^(lambdafU/(lambdafU-1)))*(epsilU*((uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) 
             *(( exp(lhU)*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU ) );

// 6-created variables for estimation
dly   =  log((ygdpU*muzstarU)/ygdpU(-1))-log(muzstarUU);
dli   =  log(iU)-log(iU(-1))+log(muzstarU)-log(muzstarUU);
dlc   =  log(cU*muzstarU/cU(-1))-log(muzstarUU);
dlgd  =  log(gdU*muzstarU/gdU(-1))-log(muzstarUU);
dlpi  =  -(log(muupU)-log(muupU(-1)));
dlh   =  (lhU-lhU(-1));
linfl =  log(piU)-log(piUU);

// national income identity:
ygdpU = gdU + gndU + cU + iU/muupU;

// capital law of motion
kbarU - (1-deltaUU)*(kbarU(-1)/(muzstarU*upsilUU)) - (1-SXU)*iU;

// sticky price/wage equations....

// p-star equation
pstarU = ((1-xipUU)*(KpXU/FpXU)^(lambdafU/(1-lambdafU))+xipUU*(piU(-1)*pstarU(-1)/piU)^(lambdafU/(1-lambdafU)))^((1-lambdafU)/lambdafU);
 
// w-star equation
wstarU = ( (1-xiwUU) * ((psiLXUU*KwXU/(wU*FwXU))^(lambdawUU/(1-lambdawUU*(1+sigmaLXUU)))) 
  + xiwUU * (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) ) 
    * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) * wstarU(-1))^(lambdafUU/(1-lambdafUU)) ) ^ ((1-lambdawUU)/lambdawUU);

// Fp equation  
-FpXU + zetacU*lambdazU*yzU 
 + betaUU * xipUU * ( (( (pitargetU(+1)^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1)) ^ (1/(1-lambdafU(+1))) ) * FpXU(+1);

// Kp equation
-KpXU + zetacU*(lambdafU/lambdafsUU)*lambdazU*yzU*sU
 + betaUU * xipUU * ( (( (pitargetU(+1)^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1)) ^ (lambdafU(+1)/(1-lambdafU(+1))) ) * KpXU(+1);

KpXU=FpXU * (( (1 - xipUU*(( (pitargetU^iota1UU) * (piU(-1)^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU)^(1/(1-lambdafU)) ) 
      / (1-xipUU) )^(1-lambdafU));

//wage-updating equation
pitildewU=(pitargetU^iotaw1UU)*(piU(-1)^iotaw2UU)*(pibarUU^(1-iotaw1UU-iotaw2UU));

//nominal wage inflation
piwU=piU*muzstarU*wU/wU(-1);

// Fw equation
lambdawsUU*zetacU*((wstarU^(lambdawUU/(lambdawUU-1)))*exp(lhU)*(1-taulU)*lambdazU/lambdawUU) 
  + betaUU * xiwUU * (muzstarUU^((1-iotamuUU)/(1-lambdawUU))) *( (pitildewU(+1)^(1/(1-lambdawUU))) / piU(+1) ) 
 *( (1/piwU(+1)) ^ (lambdawUU/(1-lambdawUU)) ) * (muzstarU(+1)^(iotamuUU/(1-lambdawUU)-1)) * FwXU(+1) - FwXU;

// Kw equation

-KwXU + zetacU*zetaU*((wstarU^(lambdawUU/(lambdawUU-1))*exp(lhU))^(1+sigmaLXUU)) 
 + betaUU * xiwUU * (( (pitildewU(+1)/piwU(+1)) * (muzstarUU^(1-iotamuUU)) * (muzstarU(+1)^iotamuUU) ) 
 ^ (lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))) * KwXU(+1);
 
KwXU =  ( ( (1 - xiwUU * ( ( (pitildewU/piwU)   
 * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) ) ^ (1-lambdawUU*(1+sigmaLXUU)) ) * wU * FwXU/psiLXUU;

// w-plus equation
wplusU - ( ((1-xiwUU)*( ( (1 - xiwUU * ( ( (pitildewU/piwU) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) )^(lambdawUU*(1+sigmaLXUU)) ) + xiwUU*( (( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )*wplusU(-1))^( lambdawUU*(1+sigmaLXUU)/(1-lambdawUU) ) ) )^(1/( lambdawUU*(1+sigmaLXUU)/(1-lambdawUU) )) );
 
// equations pertaining to the entrepreneur
// entrepreneur 
loansU=(qU*kbarU-nU);

// period t premium = interest paid by entrepreneurs in period t - interest earned by households in period t.
premU=(qU(-1)*kbarU(-1)/(qU(-1)*kbarU(-1)-nU(-1)))*(1+RkXU)*omegabarU-FXU(-1)*piU;

riskyRXU=(qU(-1)*kbarU(-1)/(qU(-1)*kbarU(-1)-nU(-1)))*(1+RkXU)*omegabarU;

// law of motion for aggregate net worth
-nU+(gammaU/(piU*muzstarU))*(1+RkXU-FXU(-1)*piU - muUU*GXU*(1+RkXU))*kbarU(-1)*qU(-1)+weUU+gammaU*(1+RXU(-1))*nU(-1)/(piU*muzstarU); 

// zero profit condition on banks
(qU(-1)*kbarU(-1)*(1+RkXU)*( GAMMAXU - muUU*GXU )/(nU(-1)*FXU(-1)*piU))-(qU(-1)*kbarU(-1)/nU(-1))+1;

 
// efficiency condition on standard debt contract
(1-GAMMAXU(+1))*( (1+RkXU(+1))/(FXU(-1)*piU) ) + ( (1 - FomegaXU(+1))/(1- FomegaXU(+1) - muUU*omegabarU(+1)*FprimeU(+1)) )
   * ( ( (1+RkXU(+1))/(FXU(-1)*piU) )*( GAMMAXU(+1)-muUU*GXU(+1)) - 1 ); 

FprimeU=(1/sqrt(2*3.14159265358979))*exp(-.5*((log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1))^2)/(omegabarU*sigmaU(-1));

GXU=normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) )-sigmaU(-1),0,1);

FomegaXU=normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) ),0,1);

GAMMAXU=omegabarU*(1-FomegaXU)+GXU;

// resources used up in monitoring
dU = muUU*GXU*(1+RkXU)*qU(-1)*kbarU(-1)/(muzstarU*piU);

log(sigmaU/sigmaUU) = rho_sigmaUU*log(sigmaU(-1)/sigmaUU) + sigmax;
log(gammaU/gammaUU) = rho_gammaUU*log(gammaU(-1)/gammaUU) + gammax;

// resource constraint
yzU - gndU - gdU  - cU - iU/muupU - dU - bigthetaUU*((1-gammaU)/gammaU)*(nU-weUU) - tauoU*(rkUU/sigmaaUU)*(exp(sigmaaUU*(uU-1))-1); 

// exogenous shocks

log(muzstarU/muzstarUU) = rho_muzstarUU*log(muzstarU(-1)/muzstarUU)+muzstarx;
log(tauoU/tauoUU) = rho_tauoUU*log(tauoU(-1)/tauoUU) + tau0x;
log(epsilU) = rhoUU*log(epsilU(-1))+epsilx;
log(lambdafU/lambdafUU) = rho_lambdafUU*log(lambdafU(-1)/lambdafUU)+lambdafx;
log(muupU/muupUU) = rho_muupUU*log(muupU(-1)/muupUU)+muupx;
log(zetacU/zetacUU) = rho_zetacUU*log(zetacU(-1)/zetacUU)+zetacx;
log(zetaiU/zetaiUU) = rho_zetaiUU*log(zetaiU(-1)/zetaiUU)+zetaix;
log(zetaU/zetaUU) = rho_zetaUU*log(zetaU(-1)/zetaUU)+zetax;
serialmps = rho_mps*serialmps(-1) + mps ;
log(gdU/gdUU) = rho1d*log(gdU(-1)/gdUU) + rho2d*log(gdU(-2)/gdUU) + rho3d*log(gdU(-3)/gdUU) + gdx + signalstate1(-1);          
//log(taulU/taulUU) = rho1_taul*log(taulU(-1)/taulUU) + rho2_taul*log(taulU(-2)/taulUU) + rho3_taul*log(taulU(-3)/taulUU) 
//            + taulx + resptaul*log(ygdpU(-1)/yzUU)+ dtaul*log(gdU(-1)/gdUU);
//log(taukU/taukUU) = rho1_tauk*log(taukU(-1)/taukUU) + rho2_tauk*log(taukU(-2)/taukUU) + rho3_tauk*log(taukU(-3)/taukUU) 
//            + taukx + resptauk*log(ygdpU(-1)/yzUU) + dtauk*log(gdU(-1)/gdUU);
log(gndU/gndUU) = rho1nd*log(gndU(-1)/gndUU) + rho2nd*log(gndU(-2)/gndUU) + rho3nd*log(gndU(-3)/gndUU) + gndx
                    + respnd*log(ygdpU(-1)/yzUU);
log(pitargetU/pitargetUU)=  rho_pitargetUU * ( log(pitargetU(-1)/pitargetUU) ) + pitargetx;

signalstate8=sig8;
signalstate7=signalstate8(-1)+sig7;
signalstate6=signalstate7(-1)+sig6;
signalstate5=signalstate6(-1)+sig5; 
signalstate4=signalstate5(-1)+sig4;
signalstate3=signalstate4(-1)+sig3;
signalstate2=signalstate3(-1)+sig2;
signalstate1=signalstate2(-1)+sig1;

end;

initval;
riskyRXU=(kUU/(kUU-nUU))*(1+RkXUU)*omegabarUU;
GXU=normcdf(( (log(omegabarUU)+sigmaUU^2/2)/sigmaUU )-sigmaUU,0,1);
FomegaXU=normcdf(( (log(omegabarUU)+sigmaUU^2/2)/sigmaUU ),0,1);
GAMMAXU=omegabarUU*(1-normcdf(( (log(omegabarUU)+sigmaUU^2/2)/sigmaUU ),0,1))+normcdf(( (log(omegabarUU)+sigmaUU^2/2)/sigmaUU )-sigmaUU,0,1);
FprimeU=(1/sqrt(2*3.14159265358979))*exp(-.5*((log(omegabarUU)+sigmaUU^2/2)/sigmaUU)^2)/(omegabarUU*sigmaUU);
gammaU=gammaUU;
omegabarU=omegabarUU;
loansU=(kUU-nUU);
premU=(kUU/(kUU-nUU))*(1+RkXUU)*omegabarUU-(1+RXUU);
sigmaU=sigmaUU;
dU=dUU;
nU=nUU;
pitildewU=pitildewUU;
piwU=piUU*muzstarUU;
tauoU=tauoUU;
zetaU=1;
KpXU=KpXUU;
KwXU=KwXUU;
ygdpU=gdUU + gndUU + cUU + iUU/muupUU;
muzstarU=muzstarUU;
SXU=0;
SpXU=0;
lambdazU=lambdazUU; 
linfl=0;
dlh=0;
pitargetU=pitargetUU;
muupU=muupUU;
FXU=muzstarUU/betaUU;
yzU=yzUU;
qU=qUU; 
piU=piUU;
RkXU=RkXUU; 
rkU=rkUU; 
RXU=RXUU;
pstarU=pstarUU;
wstarU=wstarUU;
wplusU=wplusUU;
kbarU=kUU;
lhU=log(hUU);
cU=cUU;
iU=iUU;
FpXU=FpXUU;
FwXU=FwXUU;
uzcU=lambdazUU*zetacUU*(1+taucUU);
sU=mcUU;
wU=wUU;
uU=1;
Util=UtilUU;
Welf=WelfUU; 
lambdafU=lambdafUU;
epsilU=1;
zetaiU=zetaiUU;
serialmps=0;
dly = 0;
dli = 0;
dlc = 0;
dlgd = 0;
dlpi = 0;
gdU=gdUU;
gndU=gndUU;
zetacU=zetacUU;
signalstate1=0;
signalstate2=0;
signalstate3=0;
signalstate4=0;
signalstate5=0;
signalstate6=0;
signalstate7=0;
signalstate8=0;

end;

steady;

// following are the shocks....the ones with zero variance are in effect not activated.
shocks;
var sigmax;
stderr 0;
var gammax;
stderr 0;
var muupx;
stderr 0;
var zetax;
stderr 0;
var pitargetx;
stderr 0;
var taulx;
stderr 0;
var taukx;
stderr 0;
var gdx;
stderr 0;
var gndx;
stderr 0;
var epsilx;
stderr 0.01;
var zetacx;
stderr 0;
var zetaix;
stderr 0;
var mps;
stderr 0.01/8;
var lambdafx;
stderr 0;
var sig1;
stderr 0;
var sig2;
stderr 0;
var sig3;
stderr 0;
var sig4;
stderr 0;
var sig5;
stderr 0;
var sig6;
stderr 0;
var sig7;
stderr 0;
var sig8;
stderr 0;
var muzstarx;
stderr 0;

end;

stoch_simul(order=1,irf=200,nograph) riskyRXU FXU wU sU cU iU ygdpU RkXU RXU epsilU piU nU qU rkU lhU premU loansU; 
 
realr_noFish_tech=FXU_epsilx;
wage_noFish_tech=wU_epsilx;
mc_noFish_tech=sU_epsilx;
cons_noFish_tech=100*cU_epsilx/cUU;
inv_noFish_tech=100*iU_epsilx/(iUU/muupUU);
gdp_noFish_tech=100*ygdpU_epsilx/(gdUU + gndUU + cUU + iUU/muupUU);
Rk_noFish_tech=RkXU_epsilx;
riskf_noFish_tech=RXU_epsilx;
risky_noFish_tech=riskyRXU_epsilx;
epsil_noFish_tech=epsilU_epsilx;
infl_noFish_tech=piU_epsilx;
networth_noFish_tech=100*nU_epsilx/nUU;
pcapital_noFish_tech=qU_epsilx;
rent_noFish_tech=rkU_epsilx;
lhours_noFish_tech=lhU_epsilx;
premium_noFish_tech=premU_epsilx;
loans_noFish_tech=100*loansU_epsilx/(gdUU + gndUU + cUU + iUU/muupUU);

realr_noFish_money=FXU_mps;
wage_noFish_money=wU_mps;
mc_noFish_money=sU_mps;
cons_noFish_money=100*cU_mps/cUU;
inv_noFish_money=100*iU_mps/(iUU/muupUU);
gdp_noFish_money=100*ygdpU_mps/(gdUU + gndUU + cUU + iUU/muupUU);;
Rk_noFish_money=RkXU_mps;
riskf_noFish_money=RXU_mps;
risky_noFish_money=riskyRXU_mps;
epsil_noFish_money=epsilU_mps;
infl_noFish_money=piU_mps;
networth_noFish_money=100*nU_mps/nUU;
pcapital_noFish_money=qU_mps;
rent_noFish_money=rkU_mps;
lhours_noFish_money=lhU_mps;
premium_noFish_money=premU_mps;
loans_noFish_money=100*loansU_mps/(gdUU + gndUU + cUU + iUU/muupUU);

save CEEplusBGGnoFisher realr_noFish_tech wage_noFish_tech mc_noFish_tech cons_noFish_tech inv_noFish_tech gdp_noFish_tech Rk_noFish_tech riskf_noFish_tech risky_noFish_tech epsil_noFish_tech infl_noFish_tech networth_noFish_tech pcapital_noFish_tech rent_noFish_tech lhours_noFish_tech premium_noFish_tech loans_noFish_tech realr_noFish_money wage_noFish_money mc_noFish_money cons_noFish_money inv_noFish_money gdp_noFish_money Rk_noFish_money riskf_noFish_money risky_noFish_money epsil_noFish_money infl_noFish_money networth_noFish_money pcapital_noFish_money rent_noFish_money lhours_noFish_money premium_noFish_money loans_noFish_money; 