%function [lnpriormom] = mother(data,Pstar,H,Z,T,trend)

function [lnpriormom] = mother(data,Pstar,H,bayestopt_,T,trend)
%at the end of dynare file DsgeLikelihood.m add the call to mother.m and add the additional term 
%lnpriormom to fval, i.d. add the following two lines:
%[lnpriormom] = mother(data,Pstar,H,bayestopt_,T,trend);
%fval    = (likelihood-lnprior-real(lnpriormom));
%then inside mother, uncomment lines

p=0;
TT=size(data,2);
%TT=0;
%TT=100; %10000000;
%
%
%the priors include a metric across the var coefficients of a p-lag var implied by the
%model and the corresponding var coefficients associated with a prior-specified var.
%the prior-specified var is characterized in terms of second moments,
%rather that var parameters per se.
%If p=0, then the sole focus is on variance. If p=1, the first lag
%autocovariance is included, etc.
%TT indicates the amount of weight attached to the prior. If TT is the same
%as the number of observations in the sample, then you assign the same
%weight to prior and sample.
%As a default, the prior second moments are computed from the same sample
%used to find the posterior mode. This could be changed by making the
%appropriate adjustment to the following code.


if TT > 0

    Y=data(:,1+p:end)';
    Tsamp=size(Y,1);
    n=size(Y,2);
    X=ones(Tsamp,1);
    if p > 0
        for ii = 1:p
            X=[X data(:,[1+p-ii:end-ii])'];
        end
    end
    gamxx=(X'*X)/Tsamp;
    gamxy=(X'*Y)/Tsamp;
    gamyy=(Y'*Y)/Tsamp;
%    dbstop in mother at 44
    mf=bayestopt_.mf;
    II=eye(size(T,2));
    Z=II(mf,:);
    
    Ey=trend(:,1);
    
    C0=Z*Pstar(:,mf) + H + Ey*Ey';  %C0=Z*Pstar(:,mf)+H+Ey*Ey'; %get the second moments around zero....
    tau=1;
    if p >=0 
        
        C1=Z*(T*Pstar(:,mf))+Ey*Ey';  %C1=Z*T*Pstar(:,mf)+Ey*Ey';
        C2=Z*(T^2*Pstar(:,mf))+Ey*Ey'; %C2=Z*T^2*Pstar(:,mf)+Ey*Ey';
        C3=Z*(T^3*Pstar(:,mf))+Ey*Ey'; %C3=Z*T^3*Pstar(:,mf)+Ey*Ey';
        C4=Z*(T^4*Pstar(:,mf))+Ey*Ey';  %C4=Z*T^4*Pstar(:,mf)+Ey*Ey';
        C5=Z*(T^5*Pstar(:,mf))+Ey*Ey';  %C5=Z*T^5*Pstar(:,mf)+Ey*Ey';
        
        if p == 0
            
            gamxxtheta=tau*tau';
            gamxytheta=Ey';

        elseif p == 1
            gamxxtheta=[tau*tau' tau*Ey'
                (tau*Ey')' C0];
            gamxytheta=[Ey'
                C1'];
        elseif p==2
            gamxxtheta=[tau*tau' tau*Ey' tau*Ey'
                (tau*Ey')' C0 C1
                (tau*Ey')' C1' C0];
            gamxytheta=[Ey'
                C1'
                C2'];
        elseif p == 3
            gamxxtheta=[tau*tau' tau*Ey' tau*Ey' tau*Ey'
                (tau*Ey')' C0 C1 C2
                (tau*Ey')' C1' C0 C1
                (tau*Ey')' C2' C1' C0];
            gamxytheta=[Ey'
                C1'
                C2'
                C3'];
        elseif p == 4
            gamxxtheta=[tau*tau' tau*Ey' tau*Ey' tau*Ey' tau*Ey'
                (tau*Ey')' C0 C1 C2 C3
                (tau*Ey')' C1' C0 C1 C2
                (tau*Ey')' C2' C1' C0 C1
                (tau*Ey')' C3' C2' C1' C0];
            gamxytheta=[Ey'
                C1'
                C2'
                C3'
                C4'];
        elseif p == 5
            gamxxtheta=[tau*tau' tau*Ey' tau*Ey' tau*Ey' tau*Ey' tau*Ey'
                (tau*Ey')' C0 C1 C2 C3 C4
                (tau*Ey')' C1' C0 C1 C2 C3
                (tau*Ey')' C2' C1' C0 C1 C2
                (tau*Ey')' C3' C2' C1' C0 C1
                (tau*Ey')' C4' C3' C2' C1' C0];
            gamxytheta=[Ey'
                C1'
                C2'
                C3'
                C4'
                C5'];
        else
            error('fatal (mother) inadmissible value for p')
        end
    end

    phi= gamxxtheta\gamxytheta;
    sigma=C0-(gamxytheta)'*phi;

    if rank(sigma) < size(sigma,1) || min(eig(sigma)) <0
        %warning('(mother) inverting sigma is causing problems')
        %sigma = generalized_cholesky(sigma);
        lnpriormom= -40e12;
    else
        %lnpriormom=-.5*n*TT*log(2*pi)-.5*TT*log(abs(det(sigma)))-.5*TT*trace(invsigma*(gamyy-2*phi'*gamxy+phi'*gamxx*phi));
        lnpriormom=-.5*n*TT*log(2*pi)-.5*TT*log(abs(det(sigma)))-.5*TT*trace(sigma\(gamyy-2*phi'*gamxy+phi'*gamxx*phi));
    end

else

    lnpriormom=0;

end

