
%// %---Household 
lambdawUUst     =   1.20;
sigmaLXUUst      =  1; 
zetaUUst        =   1.000;  
betaUUst        =   1.03^(-.25);%this produces a higher rate of interest (given steady state inflation) than what we see in the data
nbetast         =   betaUUst; 
bUUst           =   0.7;  
psiLXUUst        =  6;  
zetacUUst       =   1; 
iotaw1UUst      =   0.56721;%0.0;  %weight on inflation target in wage-setting
iotaw2UUst      =   1-iotaw1UUst;%0.13; %weight on lag inflation in wage-setting
iotamuUUst      =   0;%weight, in wage setting, on permanent technology growth 
tauoUUst        =   1;%mean, oil shock in utilization cost function 
xiwUUst         =   .75;
%// %----- Capital Producer
SdouprXUUst      =  4;
sigmaaUUst      =   .0010000000;
muupUUst        =   1; 
zetaiUUst       =   1;

%--- Entrepreneur
FomegabarXUUst =   0.03; % BGG page 33 (.03).
muUUst        =    .12;% BGG page 33 (.12) 
gammaUUst     =   1-0.0238; % BGG page 33 1-0.0272

weUUst        =   0.03;

bigthetaUUst  =   0.3;
tauoUUst      =   1;

%// %---- Goods Producers 
muzstarUUst     =   exp(0.00529070464135);%set to match per capita gdp growth in us
upsilUUst       =   1;%exp(0.00701559493671-log(muzstarUUst));%set to allow the model to match growth in real investment
lambdafUUst     =   1.2; 

alphaUUst       =   0.36; 
psikUUst        =   0;%.92;%fraction of capital rental to be borrowed in advance 
psilUUst        =   0;%.92; %fraction of labor bill to be borrowed in advance
deltaUUst       =   0.02; 
epsilUUst       =   1; %mean, stationary neutral technology shock
xipUUst         =   0.75;

iota1UUst       =   0.91555;%0.0; %weight on inflation target
iota2UUst       =   1-iota1UUst;%1; %weight on lag inflation


%// %---- Taxes and government consumption 
etagUUst        =   .20;
etadgUUst       =   .05;
taukUUst        =   0.0000000001;%0.15; 
taulUUst        =   0.0000000001;%0.15; 
taucUUst        =   0; 
lambdawsUUst    =   1;
lambdafsUUst    =   1;
%lambdawsUUst    =   lambdawUUst;
%lambdafsUUst    =   lambdafUUst;
phist           =   0;

%// %---- Monetary Policy 
xUUst           =   muzstarUUst*(1.00861346514081)-1; %set to match average inflation
 
%// %wage/price setting index parameter, automatically set to steady state inflation when not optimizing policy 
pibarUUst       =  (1+xUUst)/muzstarUUst;
aptilUUst       =  1.75;
aytilUUst       =   0.2;
rhotilUUst      =  .8;
actilUUst       =  0.0;
pitargetUUst    = (1+xUUst)/muzstarUUst;

%shock steady states
zetaiUUst=1;
zetaUUst=1;
zetacUUst=1;

ip = 1;
if ip == 1
    lambdawUUst     =   1.05;
    betaUUst        =   1.00401002003506^(-0.25);
    nbetast         =   betaUUst;
    bUUst           =   .56;
    iotaw1UUst      =   0.3971;
    iotaw2UUst      =   1-iotaw1UUst;
    SdouprXUUst     =  37.423;
    sigmaaUUst      =   1000000;20.258;
    FomegabarXUUst  =   0.026;
     muUUst         =  .01;%0.0999;
    gammaUUst       =   1-0.022;
    weUUst          =   .02;
    bigthetaUUst    =   .02;
    aptilUUst       =  1.85;
 %   aytilUUst      =   0; 
 %  new stuff:
   % xiwUUst         =   0;
   % xipUUst         =   0;
    taulUUst        =   0;
    taukUUst        =   0;
end