function [Pstar,C1,C2,C3] = print2moments(Z,H,T,R,Q,dly,linfl,dli,dlc,RXU,dlgd,dlpi,dlh,upsilUU,muzstarUU,piUU,hUU,iUU,cUU,RXUU,mf,xparam1,Y,nvx,var_exo,lgx_,time,dlDJ,dlrealwage)
global lgy_ dr_ estim_params_
order_var=dr_.order_var;

Pstar = lyapunov_symm(T,R*Q*transpose(R));
if size(Z,1) ~= size(H,1)
    error('fatal (print2moments) wrong number of measurement errors')
end

varobs=Z*Pstar*Z'+H;

C1=T*Pstar;
C2=T^2*Pstar;
C3=T^3*Pstar;
for ii = 1:length(mf)
    for jj = ii:length(mf)
        C1(mf(ii),mf(jj))=C1(mf(ii),mf(jj))/sqrt(varobs(ii,ii)*varobs(jj,jj));
        C2(mf(ii),mf(jj))=C2(mf(ii),mf(jj))/sqrt(varobs(ii,ii)*varobs(jj,jj));
    end
end

[cy1,cy2] = auto(dly);
[pi1,pi2] = auto(linfl);
[lh1,lh2] = auto(dlh);
[li1,li2] = auto(dli);
[lc1,lc2] = auto(dlc);
[R1,R2] = auto(RXU);
[lg1,lg2] = auto(dlgd);
[lpi1,lpi2] = auto(dlpi);

% dly         
% linfl       
% dlc         
% dli         
% RXU         
% dlgd        
% dlpi        
% dlh      

fprintf(' First and second moment results for Model (data)\n')
fprintf(' variable ,   mean,         standard deviation, first order autocorrelation, second order autocorrelation\n')
fprintf(' dly (APR), %5.3f (%5.3f),      %5.3f (%5.3f),      %5.3f (%5.3f),               %5.3f (%5.3f)\n',400*log(muzstarUU),400*mean(dly),400*sqrt(varobs(1,1)),400*std(dly), (C1(mf(1),mf(1))),cy1,(C2(mf(1),mf(1))),cy2)
fprintf(' linfl (APR), %5.3f (%5.3f),      %5.3f (%5.3f),      %5.3f (%5.3f),               %5.3f (%5.3f)\n',400*log(piUU),400*mean(linfl),400*sqrt(varobs(2,2)),400*std(linfl),  (C1(mf(2),mf(2))),pi1,(C2(mf(2),mf(2))),pi2)
fprintf(' dlc (APR)  , %5.3f (%5.3f),      %5.3f (%5.3f),      %5.3f (%5.3f),               %5.3f (%5.3f)\n',400*log(muzstarUU),400*mean(dlc),sqrt(varobs(3,3)),400*std(dlc),           (C1(mf(3),mf(3))),lc1,(C2(mf(3),mf(3))),lc2)
fprintf(' dli (APR), %5.3f (%5.3f),      %5.3f (%5.3f),      %5.3f (%5.3f),               %5.3f (%5.3f)\n',400*log(upsilUU)+400*log(muzstarUU),400*mean(dli),400*sqrt(varobs(4,4)),400*std(dli),(C1(mf(4),mf(4))),li1,(C2(mf(4),mf(4))),li2)
fprintf(' Rate (APR), %5.3f (%5.3f),      %5.3f (%5.3f),      %5.3f (%5.3f),               %5.3f (%5.3f)\n',400*RXUU,400*mean(RXU),400*sqrt(varobs(5,5)),400*std(RXU),          (C1(mf(5),mf(5))),R1,(C2(mf(5),mf(5))),R2)
fprintf(' dlgd (APR), %5.3f (%5.3f),      %5.3f (%5.3f),      %5.3f (%5.3f),               %5.3f (%5.3f)\n\n',400*log(muzstarUU),400*mean(dlgd),400*sqrt(varobs(6,6)), 400*std(dlgd),(C1(mf(6),mf(6))),lg1,(C2(mf(6),mf(6))),lg2)
fprintf(' dlpi (APR), %5.3f (%5.3f),      %5.3f (%5.3f),      %5.3f (%5.3f),               %5.3f (%5.3f)\n\n',-400*log(upsilUU),400*mean(dlpi),400*sqrt(varobs(7,7)), 400*std(dlpi),(C1(mf(7),mf(7))),lpi1,(C2(mf(7),mf(7))),lpi2)
fprintf(' dlh (APR), %5.3f (%5.3f),      %5.3f (%5.3f),      %5.3f (%5.3f),               %5.3f (%5.3f)\n\n',0,400*mean(dlh),400*sqrt(varobs(8,8)), 400*std(dlh),               (C1(mf(8),mf(8))),lh1,(C2(mf(8),mf(8))),lh2)


%the following uses the Dynare smoother to obtain some information, but I
%was never able to figure it out. So, I've rewritten it all using my Kalman
%filter code (LJC).
gend=length(dly);
% mm=mean(Y')';
% Y=Y-repmat(mm,1,gend);
[atT,innov,measurement_error,filtered_state_vector,ys,trend_coeff] ...
    = DsgeSmoother(xparam1,gend,Y);

ceeoutput
return
fprintf(' Model (smoothed estimate based on the data)\n')
fprintf(' variable,   mean (mean of smoothed estimate), standard deviation (std of smoothed), first order autocorrelation (smoothed), pValue of zero ARCH hypothesis\n')
for i=1:nvx
    k = var_exo(i,1);
    [mn,sd,rho,insd,er,pValue] = statis(innov(k,:));
    fprintf([deblank(lgx_(k,:)), '    %7.5f (%7.5f),           %7.5f (%7.5f) ,            %7.5f (%7.5f),           %7.5f\n'],0, mn, xparam1(i),sd, 0, rho, pValue)
end


%    These are the variables in the state, re-ordered (i.e., lgy_(dr_.order_var,:)):
% dlc 1         
% dli 2         
% dly 3         
% lhU 4         
% piwU 5        
% rkU  6        
% rrU  7        
% sU   8        
% Util 9        
% epsilU 10      
% kbarU 11       
% muupU 12       
% pstarU 13      
% RXU 14         
% serialmps 15    
% signalstate1 16 
% signalstate10 17
% signalstate11 18
% signalstate12 19
% signalstate2  20
% signalstate3 21
% signalstate4 22
% signalstate5 23
% signalstate6 24
% signalstate7 25
% signalstate8 26
% signalstate9 27
% wplusU 28      
% wstarU 29      
% yzU 30         
% cU 31          
% iU 32          
% lambdafU 33    
% piU 34         
% qU 35          
% wU 36          
% zetacU 37      
% zetaiU 38      
% FpXU 39        
% FwXU 40        
% RkXU 41        
% uzcU 42        
% Welf 43 

%these are the exogenous variables in alphabetical order
% lambdafx
% mps
% muupx
% PATRIOT
% sig1
% sig10
% sig11
% sig12
% sig2
% sig3
% sig4
% sig5
% sig6
% sig7
% sig8
% sig9
% zetacx
% zetaix

%dly piU lhU dli dlc RXU
figure
ip=1;
subplot(231)
plot(time,filtered_state_vector(1,[2:end])+ip*measurement_error(5,:),time,Y(5,:)-mean(Y(5,:)),'*-')
title('consumption growth')
axis tight
legend('smoothed','actual')
subplot(232)
plot(time,filtered_state_vector(2,[2:end])+ip*measurement_error(4,:),time,Y(4,:)-mean(Y(4,:)),'*-')
axis tight
title('investment growth')
subplot(233)
plot(time,filtered_state_vector(3,[2:end])+ip*measurement_error(1,:),time,Y(1,:)-mean(Y(1,:)),'*-')
axis tight
title('output growth')
subplot(234)
plot(time,filtered_state_vector(4,[2:end])+ip*measurement_error(3,:),time,Y(3,:)-mean(Y(3,:)),'*-')
axis tight
title('log hours')
subplot(235)
plot(time,filtered_state_vector(35,[2:end])+ip*measurement_error(2,:),time,Y(2,:)-mean(Y(2,:)),'*-')
axis tight
title('inflation')
subplot(236)
plot(time,filtered_state_vector(15,[2:end])+ip*measurement_error(6,:),time,Y(6,:)-mean(Y(6,:)),'*-')
axis tight
title('interest rate')
hout=suptitle('demeaned raw data versus smoothed version (produced by Dynare code)');

