function [q,piss,Rk,rk,R,pstar,wstar,wplus,kbar,L,lambdaz,c,yz,gnd,gd,inv,Fp,Kp,Fw,Kw,uzc,s,phi,wtilde,u,check] = ...
    sstate(muup,x,muzstar,beta,tauk,delta,upsil,iota1,iota2,xip,lambdaf,iotaw1,iotaw2,xiw,sigmaL, ...
    zeta,zetac,alpha,epsil,etag,etadg,pibar,lambdaw,psil,psik,b,taul,tauc,psiL,phi,lambdafs,lambdaws) 


%this computes the steady state for the version of the CMR model without
%entrepreneurs and without banks. 

u=1;
q=1/muup; %eqqq4
piss=(1+x)/muzstar; %eqqq22
%pibar=piss;
Rk=piss*muzstar/beta-1; %eqqq24
rk=(Rk-tauk*delta+1)*upsil*q/piss - (1-delta)*q;
rk=rk/(1-tauk);
R=((piss*muzstar/beta) - 1);

[pitild,pstar,piw,pitildw,wstar,wplus,s,check] = ssstate(piss, ...
    muup,muzstar,beta,tauk,delta,upsil,iota1,iota2,pibar, ...
    xip,lambdaf,iotaw1,iotaw2,xiw,lambdaw,sigmaL,alpha,epsil,lambdafs);

if check == 1
    pitild=[];
    pstar=[];
    wstar=[];
    wplus=[];
    kbar=[];
    L=[];
    lambdaz=[];
    c=[];
    yz=[];
    g=[];
    inv=[];
    Fp=[];
    Kp=[];
    Fw=[];
    Kw=[];
    uzc=[];
    s=[];
    phi=[];
    wtilde=[];
    u=[];
    return
end
    

wtilde=(1/(1+psil*R))*((alpha^alpha)*((1-alpha)^(1-alpha))*s*epsil/( (rk*(1+psik*R))^alpha) )^(1/(1-alpha));

Lk= ((rk*(1+psik*R)/(s*alpha*epsil))^(1/(1-alpha))) / (upsil*muzstar*(wstar^(lambdaw/(lambdaw-1))));

A = (1-etag) * s * epsil * ((upsil*muzstar)^(-alpha)) * ( ((wstar^(lambdaw/(lambdaw-1))) * Lk)^(1-alpha) ) ...
    - (1-(1-delta)/(muzstar*upsil))/muup;
 
l=wstar^(lambdaw/(lambdaw-1))*Lk;
bb1=((1-xiw*(pitildw/piss)^(1/(1-lambdaw)))/(1-xiw))^(1-lambdaw*(1+sigmaL));
bb2=(1-beta*xiw*(pitildw/piss)^(lambdaw*(1+sigmaL)/(1-lambdaw)))/(1-xiw*beta*(pitildw/piss)^(1/(1-lambdaw)));
D=((muzstar-b*beta)/(A*(muzstar-b)))*bb1*bb2*(1-taul)*wtilde/((1+tauc)*(lambdaw/lambdaws)*psiL*zeta*zetac*(l^sigmaL));
kbar=D^(1/(1+sigmaL));
L=kbar*Lk;
c=A*kbar;
ucz=(muzstar-b*beta)*zetac/(c*(muzstar-b));
lambdaz=ucz/(zetac*(1+tauc));
yz=s*epsil*((1/(upsil*muzstar))^alpha)*(l^(1-alpha))*kbar;
gd=etadg*yz; 
gnd=(etag-etadg)*yz;
g=gd+gnd;
inv=kbar-(1-delta)*kbar/(muzstar*upsil);

[Fp,Kp,Fw,Kw] = sssstate(lambdaz,yz,pitild,piss,lambdaf,beta,xip,s,zetac, ...
    wstar,lambdaw,L,taul,muzstar,sigmaL,xiw,pitildw,piw,zeta,lambdaws,lambdafs);

uzc=(1/c)*(muzstar-b*beta)*zetac/(muzstar-b);

aa1 = (1-beta*xip*((pitild/piss)^(lambdaf/(1-lambdaf))))/(1-beta*xip*((pitild/piss)^(1/(1-lambdaf))));
aa2 = ( (1-xip*((pitild/piss)^(1/(1-lambdaf))))/(1-xip) )^(1-lambdaf);
phi = ((lambdaf/lambdafs)/(aa1*aa2) - pstar^(lambdaf/(1-lambdaf)))*yz;

%now, check the steady state

[err] = checksstate(s,rk,wtilde,R,L,kbar,wstar,Rk,q,piss, ...
    piw,uzc,inv,pstar,lambdaz,yz,Fp,Kp,g,c,Fw,Kw,wplus,pitild,pitildw, ...
    alpha,psik,psil,epsil,muzstar,upsil,lambdaw,lambdaf,muup,tauk,delta, ...
    b,beta,zetac,x,xip,xiw,tauc,taul,sigmaL,zeta,phi,lambdaws,lambdafs);
 
if max(abs(err)) > .1e-8
    check=1;
    return
end


