function [g,rk,n,k,h,I,w,d,c,lambdaz,yz,sigma,omegabar,phi,mc,pitild,pstar,piw, ...
        pitildw,wstar,wplus,Rk,R,Fp,Kp,Fw,Kw,ucz,q,Gamma,Gam_muG] = steadystate(lambdaf, ...
    infl,muz,beta,delta,Fomegabar,mu,alpha,gam,sigmaL,psiL,lambdaw,we,bigtheta,b,phi, ...
    muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,lambdaws,lambdafs, ...
    etag,zetac,zeta,taul,psik,psil,tauc,iotamu)

if abs(mu) < .1e-8

    hk=(1/muz)*((lambdaf/lambdafs)*((muz/beta)-(1-delta))/alpha)^(1/(1-alpha));
    a=((1-alpha)/(muz*(lambdaf/lambdafs)*(lambdaw/lambdaws)*psiL*(muz*hk)^(alpha+sigmaL)))*(muz-b*beta)/(muz-b);
    bb=(1-etag)*(lambdafs/(lambdaf*muz))*(muz*hk)^(1-alpha)-(1-(1-delta)/muz);
    if bb < 0
        error('fatal (steadystate) negative value of b')
    end
    kstart=muz*(a/bb)^(1/(1+sigmaL));
    k1=kstart*1.5;
    [ff] = findss(kstart,muz,sigmaL,bigtheta,gam,beta,we,a,bb);
    if abs(ff) < .1e-10
        k=kstart;
    else
        [ff1] = findss(k1,muz,sigmaL,bigtheta,gam,beta,we,a,bb);
        if ff*ff1 > 0
            error('fatal (steadystate) failed to bracket steady state')
        end
        opt=optimset;
        [x,fval,exitflag]=fzero('findss',[kstart k1],opt,muz,sigmaL,bigtheta,gam,beta,we,a,bb);
        if abs(fval) > .1e-9 | abs(imag(fval)) > .1e-9 | abs(imag(x)) > .1e-9 | x < 0
            error('fatal (steadystate) failed to find a steady state')
        end
        k=x;
    end
    h=k*hk;
    n=we/(1-gam/beta);
    yz=(k/muz)^alpha*h^(1-alpha)/(lambdaf/lambdafs);
    g=etag*yz;
    I=(1-(1-delta)/muz)*k;
    c=yz-g-I-bigtheta*((1-gam)/gam)*(n-we);
    rk=alpha*(muz*hk)^(1-alpha)/(lambdaf/lambdafs);
    w=(1-alpha)*(muz*hk)^(-alpha)/(lambdaf/lambdafs);
    d=0;
    lambdaz=((muz-b*beta)/(muz-b))/c;
    mc=lambdafs/lambdaf;
    pstar=1;
    wstar=1;
    wplus=1;
    q=1;
    Fp=lambdaz*yz/(1-beta*xip);
    Kp=Fp;
    Fw=(lambdaz*h/(lambdaw/lambdaws))/(1-beta*xiw);
    Kw=Fw*w/psiL;
    errr4=Kw-h^(1+sigmaL)/(1-beta*xiw);
    pitildw=infl;
    piw=muz*infl;
    R=infl*muz/beta-1;
    pitild=infl
    Rk=R;
    phi=yz*(lambdaf/lambdafs-1);
    [omegabar,sigma,Gamma,G,Gam_muG] = findentre(Fomegabar,k,n);
    sw=1;

else

    %| abs(psik) > .1e-8 |  abs(psil) > .1e-8

    if abs(taul) > .1e-8 | abs(tauc) > .1e-8  |abs(iotamu) > .1e-8
        error('fatal (steadystate) cannot handle this case');
    end

    sw=0;
    if phi == 0;%in this case, solve for phi assuming inflation = pibar
        sw=1;
        infl=pibar;
    end

    R=infl*muz/beta-1;
    rkk=[muz/beta-(1-delta)+0.0000000001:.001:0.05];
    %rkk=[.0333:.0000001:.0334];

    rk=rkk(1);

    [ffold] = ssteadystate(rk,phi,Fomegabar,mu,gam,delta,infl,R,muz,lambdaf, ...
        bigtheta,we,beta,psiL,sigmaL, ...
        lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw,lambdaws,lambdafs,etag,psik,psil);
    ix=0;
    fx(1)=ffold;
    for ii = 2:length(rkk)
        rk=rkk(ii);
        [ff] = ssteadystate(rk,phi,Fomegabar,mu,gam,delta,infl,R,muz,lambdaf, ...
            bigtheta,we,beta,psiL,sigmaL, ...
            lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw,lambdaws,lambdafs,etag,psik,psil);

        if ff > 0 & ffold < 0

            ix=ix+1;
            I(ix)=ii;
            break

        end
        ffold=ff;
        fx(ii)=ff;
    end

    if ix > 1
        error('fatal (steadystate) found more than one steady state')
    end
    if ix == 0

        error('fatal (steadystate) failed to bracket a steady state')
    end
    rk1=rkk(I(ix)-1);
    rk2=rkk(I(ix));

    opt=optimset('diagnostics','on','LevenbergMarquardt','on','TolX',1e-16,'TolFun',1e-16);
    [rkopt,fval,exitflag,output] =   fzero(@ssteadystate,[rk1,rk2],opt,phi,Fomegabar,mu, ...
        gam,delta,infl,R,muz,lambdaf,bigtheta,we,beta,psiL,sigmaL, ...
        lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw,lambdaws,lambdafs,etag,psik,psil);
    if abs(fval ) > .1e-9 | abs(imag(rkopt))>.1e-10 | exitflag <= 0
        error('fatal (steadystate) failed to find steady state')
    end

    rk=rkopt;

    [ff,g,n,k,h,I,w,d,c,lambdaz,yz,sigma,omegabar,phi,mc,pitild,pstar,piw, ...
        pitildw,wstar,wplus,Rk,q,Gamma,Gam_muG] = ssteadystate(rk,phi,Fomegabar,mu, ...
        gam,delta,infl,R,muz,lambdaf,bigtheta,we,beta,psiL,sigmaL, ...
        lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw,lambdaws,lambdafs,etag,psik,psil);



    [Fp,Kp,Fw,Kw] = sssstate(lambdaz,yz,pitild,infl,lambdaf,beta,xip,mc,zetac, ...
        wstar,lambdaw,h,taul,muz,sigmaL,xiw,pitildw,piw,zeta,lambdaws,lambdafs);

end

x=infl*muz-1;

ucz=(muz*zetac/(c*muz-b*c)) - b*beta*zetac/(c*muz-b*c);

%do a check, to verify the steady state equations are satisfied.
[err] = checksteady_ceebgg(mc,rk,w,R,h,k,wstar,Rk,q,infl, ...
    piw,ucz,I,pstar,lambdaz,yz,Fp,Kp,g,c,Fw,Kw,wplus,pitild,pitildw, ...
    alpha,psik,psil,epsil,muz,upsil,lambdaw,lambdaf,muup,tauk,delta, ...
    b,beta,zetac,x,xip,xiw,tauc,taul,sigmaL,zeta,phi,Gamma,omegabar, ...
    Fomegabar,mu,gam,we,n,bigtheta,Gam_muG,psiL,sw,lambdaws,lambdafs);


if max(abs(err)) > .1e-9
    error('fatal (steadystate) failed to find a steady state for cee&bgg model')
end